SystemOrganization addCategory: #LoomPharo!

Object subclass: #LoomExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LoomPharo'!

!LoomExporter methodsFor: 'exporter' stamp: 'AlexandreBergel 9/6/2012 09:21'!
toVW

	"
	self new toVW
	
	If I'm executed, I generate a st file called Loom-AlexandreBergel.(*version*)-vw5.st in the same folder that contains the image (./contents/resources).
	To import Loom in VW your should have a Loom version already loaded in the VisualWorks image and follow this steps:
	
	1) Remove the Loom package and agree with all the classes removal in the Loom-VWSpecific. 
	2) Create the Loom package again and do right click in the package, select 'file into' and choose the file you exported. 
	3) FInally restore the Loom-VWSpecific package by loading the latest version of it from the public repository.
	
	"
	Gofer new
		squeaksource: 'PackageInfo';
		package: 'PackageInfo-Exporters';
		load.
	
	(Smalltalk at: #VW5PackageExporter)
	        fileOutPackageNamed:  'Loom' 
 	       withNamespace: 'Loom'.
	
	! !

Object subclass: #LoomInspector
	instanceVariableNames: 'workspace profiler refreshProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LoomPharo'!

!LoomInspector methodsFor: 'public' stamp: 'AlexandreBergel 9/6/2012 08:36'!
open
	Smalltalk garbageCollectMost.
	
	workspace := Workspace new.
	workspace toggleStylingActive; open.
	
	profiler := LoomProfiler new profileAllProcesses.

	self refreshAutomatic! !

!LoomInspector methodsFor: 'refreshing' stamp: 'AlexandreBergel 9/5/2012 19:27'!
refresh
	| stream |
	stream := WriteStream on: String new.
	self writeHeaderOn: stream.
	profiler threadsDo: [ :loomThread |  
		loomThread printOn: stream.
		stream cr.
		 ].
	
	workspace setContent: stream contents.! !

!LoomInspector methodsFor: 'refreshing' stamp: 'AlexandreBergel 9/5/2012 19:13'!
refreshAutomatic
	refreshProcess := [ [ profiler isProfiling ] whileTrue:  [ 
							self refresh.
							(Delay forMilliseconds: 1000) wait. ] ] fork.! !

!LoomInspector methodsFor: 'reporting' stamp: 'AlexandreBergel 9/5/2012 19:24'!
writeHeaderOn: stream
	stream nextPutAll: 'Loom Inspector, last refresh ', Time now printString, String cr.! !
